exports.cliVersion = '>=3.2';

exports.init = function (logger, config, cli) {

	cli.on('build.android.copyResource', {
		pre: function (data, next) {
			logger.log('[FUNCTION-PRE-HOOK] build.android.copyResource'.magenta);
			next(null, data);
		},
		post: function (data, next) {
			logger.log('[FUNCTION-POST-HOOK] build.android.copyResource'.magenta);
			next(null, data);
		}
	});

	cli.on('build.android.compileJsFile', {
		pre: function (data, next) {
			logger.log('[FUNCTION-PRE-HOOK] build.android.compileJsFile'.magenta);
			next(null, data);
		},
		post: function (data, next) {
			logger.log('[FUNCTION-POST-HOOK] build.android.compileJsFile'.magenta);
			next(null, data);
		}
	});


	cli.on('build.ios.copyResource', {
		pre: function (data, next) {
			logger.log('[FUNCTION-PRE-HOOK] build.ios.copyResource'.magenta);
			next(null, data);
		},
		post: function (data, next) {
			logger.log('[FUNCTION-POST-HOOK] build.ios.copyResource'.magenta);
			next(null, data);
		}
	});

	cli.on('build.ios.compileJsFile', {
		pre: function (data, next) {
			logger.log('[FUNCTION-PRE-HOOK] build.ios.compileJsFile'.magenta);
			next(null, data);
		},
		post: function (data, next) {
			logger.log('[FUNCTION-POST-HOOK] build.ios.compileJsFile'.magenta);
			next(null, data);
		}
	});

	cli.on('build.android.javac', {
		pre: function (data, next) {
			logger.log('[FUNCTION-PRE-HOOK] build.android.javac'.magenta);
			next(null, data);
		},
		post: function (data, next) {
			logger.log('[FUNCTION-POST-HOOK] build.android.javac'.magenta);
			next(null, data);
		}
	});

	cli.on('build.config', {
		pre: function (data, next) {
			logger.log('[FUNCTION-PRE-HOOK] build.config'.magenta);
			next(null, data);
		},
		post: function (data, next) {
			logger.log('[FUNCTION-POST-HOOK] build.config'.magenta);
			next(null, data);
		}
	});

	cli.on('build.android.config', {
		pre: function (data, next) {
			logger.log('[FUNCTION-PRE-HOOK] build.android.config'.magenta);
			next(null, data);
		},
		post: function (data, next) {
			logger.log('[FUNCTION-POST-HOOK] build.android.config'.magenta);
			next(null, data);
		}
	});

	cli.on('build.pre.construct', function (builder, next) {
		logger.log('[EVENT-HOOK] build.pre.construct'.magenta);
		next();
	});

	cli.on('build.pre.compile', function (builder, next) {
		logger.log('[EVENT-HOOK] build.pre.compile'.magenta);
		next();
	});

	cli.on('build.android.writeBuildManifest', {
		pre: function (data, next) {
			logger.log('[FUNCTION-PRE-HOOK] build.android.writeBuildManifest'.magenta);
			next(null, data);
		},
		post: function (data, next) {
			logger.log('[FUNCTION-POST-HOOK] build.android.writeBuildManifest'.magenta);
			next(null, data);
		}
	});

	cli.on('build.android.dexer', {
		pre: function (data, next) {
			logger.log('[FUNCTION-PRE-HOOK] build.android.dexer'.magenta);
			dump({
				type: data.type,
				args: data.args,
				fn: data.fn.toString()
			});
			next(null, data);
		},
		post: function (data, next) {
			logger.log('[FUNCTION-POST-HOOK] build.android.dexer'.magenta);
			next();
		}
	});

	cli.on('build.android.aapt', {
		pre: function (data, next) {
			logger.log('[FUNCTION-PRE-HOOK] build.android.aapt'.magenta);
			next(null, data);
		},
		post: function (data, next) {
			logger.log('[FUNCTION-POST-HOOK] build.android.aapt'.magenta);
			next();
		}
	});

	cli.on('build.android.jarsigner', {
		pre: function (data, next) {
			logger.log('[FUNCTION-PRE-HOOK] build.android.jarsigner'.magenta);
			next(null, data);
		},
		post: function (data, next) {
			logger.log('[FUNCTION-POST-HOOK] build.android.jarsigner'.magenta);
			next();
		}
	});

	cli.on('build.android.zipalign', {
		pre: function (data, next) {
			logger.log('[FUNCTION-PRE-HOOK] build.android.zipalign'.magenta);
			next(null, data);
		},
		post: function (data, next) {
			logger.log('[FUNCTION-POST-HOOK] build.android.zipalign'.magenta);
			next();
		}
	});

	cli.on('build.post.compile', function (builder, next) {
		logger.log('[EVENT-HOOK] build.post.compile'.magenta);
		next();
	});

	cli.on('build.android.startEmulator', {
		pre: function (data, next) {
			logger.log('[FUNCTION-PRE-HOOK] build.android.startEmulator'.magenta);
			next();
		},
		post: function (data, next) {
			logger.log('[FUNCTION-POST-HOOK] build.android.startEmulator'.magenta);
			next();
		}
	});

	cli.on('build.finalize', function (builder, next) {
		logger.log('[EVENT-HOOK] build.finalize'.magenta);
		next();
	});

};